import { csv, select } from 'd3';
import { scatterPlot } from './scatterPlot';

// Data set URI
const csvUrl = 'https://gist.githubusercontent.com/prashanthyamala/fc7bbb6153d5cfc0e69c03f7eeff578f/raw/d11ea3a37205cda0de80576596b8cbf468241fc1/supermarket_sales';  

// Format the Data from the URI response
const parseRow = (d) => {
  d.Price= +d.Price;
  d.Quantity = +d.Quantity;
  return d;
};

const width = window.innerWidth;
const height = window.innerHeight;

// Appends a SVG in the body of HTML
const svg = select('body')
  .append('svg')
  .attr('width', width)
  .attr('height', height);

const main = async () => {
  
  // Creating a new Scatter Plot object
  const plot = scatterPlot()
    .width(width)
    .height(height)
    .data(await csv(csvUrl, parseRow))
    .xValue((d) => d.Quantity)
    .yValue((d) => d.Price)
    .margin({
      top: 70,
      right: 100,
      bottom: 70,
      left: 100,
    })
    .radius(5);

  // Plotting the Scatter Plot axes based on the given parameters
  svg.call(plot);
  
svg
        	.append("text")
        	.attr('transform', 'rotate(-90)')
        	.attr('x',0 - (height /2))
        	.attr("y",  height/12)
        	.style("text-anchor", "middle")
        	.style("font-style","italic")
        	.style("font-weight","bold")
        	.text("Price");
  // Title
svg.append("text").attr("x", 450).attr("y", 20).text("Retail_sales").style("font-size", "35px").attr("alignment-baseline","middle")
  
svg.append("text").attr("x", 150).attr("y", 70).text("A- Clothing").style("font-size", "20px").attr("alignment-baseline","middle")
svg.append("text").attr("x", 150).attr("y", 100).text("B- gadgets").style("font-size", "20px").attr("alignment-baseline","middle")
svg.append("text").attr("x", 150).attr("y", 130).text("C- appliances").style("font-size", "20px").attr("alignment-baseline","middle")

  const columns = [
    'Quantity',
    'Price',
  ];
  
  svg.append("circle").attr("cx",130).attr("cy",70).attr("r", 6).style("fill", "blue")
		svg.append("circle").attr("cx",130).attr("cy",100).attr("r", 6).style("fill", "purple")
		svg.append("circle").attr("cx",130).attr("cy",130).attr("r", 6).style("fill", "orange")
   // plot petal_width on x-axis 
    
     // plot sepal_width on y-axis
 
  // Plotting the data on the Scatter Plot
  
  let i = 0;
 	setInterval(() => {
    plot.xValue((d) => d[columns[i % columns.length]]);
    svg.call(plot);
    
     if(i % columns.length==0)
    svg
        	.append("text")
        	.attr("x", width / 2 )
      		.attr("y", 480 )
        	.style("text-anchor", "middle")
        	.style("font-style","italic")
        	.style("font-weight","bold")
      		.text("Quantity");
  
    i++;
  }, 4000);
};
main();




